package com.ejie.ab79.dao.preguntasRespuestas;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.REST.servicioWeb.Opcion;
import com.ejie.ab79.model.preguntasRespuestas.OpcionesPrePro;
import com.ejie.ab79.model.preguntasRespuestas.PreguntasProtocolo;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * OpcionesPreProDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class OpcionesPreProDaoImpl implements OpcionesPreProDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDOPCIONPREPRO", "IDPREGUNTAPROTOCOLO",
			"DESCRIPCIONCASTELLANO", "DESCRIPCIONEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<OpcionesPrePro> rwMap = new RowMapper<OpcionesPrePro>() {
		public OpcionesPrePro mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new OpcionesPrePro(resultSet.getInt("IDOPCIONPREPRO"), resultSet.getInt("IDPREGUNTAPROTOCOLO"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"));
		}
	};

	private RowMapper<OpcionesPrePro> rwMapPK = new RowMapper<OpcionesPrePro>() {
		public OpcionesPrePro mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new OpcionesPrePro(resultSet.getInt("IDOPCIONPREPRO"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<OpcionesPrePro>> rwMapJerarquia = new RowMapper<JerarquiaDto<OpcionesPrePro>>() {
		public JerarquiaDto<OpcionesPrePro> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			OpcionesPrePro opcionesprepro = new OpcionesPrePro(resultSet.getInt("IDOPCIONPREPRO"),
					resultSet.getInt("IDPREGUNTAPROTOCOLO"), resultSet.getString("DESCRIPCIONCASTELLANO"),
					resultSet.getString("DESCRIPCIONEUSKERA"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<OpcionesPrePro> jerarquia = new JerarquiaDto<OpcionesPrePro>();
			jerarquia.setModel(opcionesprepro);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<Opcion> rwMapOpcionesREST = new RowMapper<Opcion>() {
		public Opcion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Opcion opcion = new Opcion();
			opcion.setIdentificadorOpcion(resultSet.getInt("identificadoropcion"));
			opcion.setDescripcionCastellano(resultSet.getString("descripcioncastellano"));
			opcion.setDescripcionEuskera(resultSet.getString("descripcioneuskera"));

			return opcion;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the OpcionesPrePro table.
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro
	 * @return OpcionesPrePro
	 */
	public OpcionesPrePro add(OpcionesPrePro opcionesprepro) {

		int idOpcionPrePro = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7917T00.NEXTVAL FROM DUAL",
				Integer.class);
		opcionesprepro.setIdOpcionPrePro(idOpcionPrePro);

		String query = "INSERT INTO OPCIONES_PRE_PRO (ID_OPCION_PRE_PRO, ID_PREGUNTA_PROTOCOLO, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,?)";
		this.jdbcTemplate.update(query, opcionesprepro.getIdOpcionPrePro(), opcionesprepro.getIdPreguntaProtocolo(),
				opcionesprepro.getDescripcionCastellano(), opcionesprepro.getDescripcionEuskera(),
				opcionesprepro.getFechaRegistro(), opcionesprepro.getUsuarioRegistro());
		return opcionesprepro;
	}

	/**
	 * Updates a single row in the OpcionesPrePro table.
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro
	 * @return OpcionesPrePro
	 */
	public OpcionesPrePro update(OpcionesPrePro opcionesprepro) {
		String query = "UPDATE OPCIONES_PRE_PRO SET ID_PREGUNTA_PROTOCOLO=?, DESCRIPCION_CASTELLANO=?, DESCRIPCION_EUSKERA=?, FECHA_REGISTRO=?, USUARIO_REGISTRO=? WHERE ID_OPCION_PRE_PRO=?";
		this.jdbcTemplate.update(query, opcionesprepro.getIdPreguntaProtocolo(),
				opcionesprepro.getDescripcionCastellano(), opcionesprepro.getDescripcionEuskera(),
				opcionesprepro.getFechaRegistro(), opcionesprepro.getUsuarioRegistro(),
				opcionesprepro.getIdOpcionPrePro());
		return opcionesprepro;
	}

	/**
	 * Finds a single row in the OpcionesPrePro table.
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro
	 * @return OpcionesPrePro
	 */
	@Transactional(readOnly = true)
	public OpcionesPrePro find(OpcionesPrePro opcionesprepro) {
		String query = "SELECT t1.ID_OPCION_PRE_PRO IDOPCIONPREPRO, t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM OPCIONES_PRE_PRO t1  WHERE t1.ID_OPCION_PRE_PRO = ?  ";

		List<OpcionesPrePro> opcionespreproList = this.jdbcTemplate.query(query, this.rwMap,
				opcionesprepro.getIdOpcionPrePro());
		return DataAccessUtils.uniqueResult(opcionespreproList);
	}

	/**
	 * Removes a single row in the OpcionesPrePro table.
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro
	 * @return
	 */
	public void remove(OpcionesPrePro opcionesprepro) {
		String query = "DELETE FROM OPCIONES_PRE_PRO WHERE ID_OPCION_PRE_PRO=?";
		this.jdbcTemplate.update(query, opcionesprepro.getIdOpcionPrePro());
	}

	@Override
	public void removeByPregunta(PreguntasProtocolo preguntaProtocolo) {
		String query = "DELETE FROM OPCIONES_PRE_PRO WHERE ID_PREGUNTA_PROTOCOLO=?";
		this.jdbcTemplate.update(query, preguntaProtocolo.getIdPreguntaProtocolo());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<OpcionesPrePro> getMultiple(OpcionesPrePro filterOpcionesPrePro, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterOpcionesPrePro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, OpcionesPrePro.class, params,
				"ID_OPCION_PRE_PRO");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the OpcionesPrePro table.
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<OpcionesPrePro>
	 */
	@Transactional(readOnly = true)
	public List<OpcionesPrePro> findAll(OpcionesPrePro opcionesprepro, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_OPCION_PRE_PRO IDOPCIONPREPRO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM OPCIONES_PRE_PRO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(opcionesprepro);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, OpcionesPreProDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the OpcionesPrePro table using like.
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<OpcionesPrePro>
	 */
	@Transactional(readOnly = true)
	public List<OpcionesPrePro> findAllLike(OpcionesPrePro opcionesprepro, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_OPCION_PRE_PRO IDOPCIONPREPRO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM OPCIONES_PRE_PRO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(opcionesprepro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, OpcionesPreProDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<Opcion> findOpcionesREST(Integer idPreguntaProtocolo) {
		String query = "SELECT t1.id_opcion_pre_pro identificadoropcion, t1.descripcion_castellano descripcioncastellano, t1.descripcion_euskera descripcioneuskera FROM opciones_pre_pro t1 WHERE t1.id_pregunta_protocolo = ?";

		return this.jdbcTemplate.query(query, this.rwMapOpcionesREST, idPreguntaProtocolo);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the OpcionesPrePro table.
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(OpcionesPrePro opcionesprepro) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM OPCIONES_PRE_PRO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(opcionesprepro);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the OpcionesPrePro table using like.
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(OpcionesPrePro opcionesprepro, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM OPCIONES_PRE_PRO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(opcionesprepro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of OpcionesPrePro selected for rup_table
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OpcionesPrePro>>
	 */
	@Override
	public List<TableRowDto<OpcionesPrePro>> reorderSelection(OpcionesPrePro opcionesprepro,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_OPCION_PRE_PRO IDOPCIONPREPRO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM OPCIONES_PRE_PRO t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(opcionesprepro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, OpcionesPrePro.class,
				filterParamList, "ID_OPCION_PRE_PRO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<OpcionesPrePro>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            OpcionesPrePro
	 * @param searchParams
	 *            OpcionesPrePro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OpcionesPrePro>>
	 */
	@Override
	public List<TableRowDto<OpcionesPrePro>> search(OpcionesPrePro filterParams, OpcionesPrePro searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_OPCION_PRE_PRO IDOPCIONPREPRO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM OPCIONES_PRE_PRO t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, OpcionesPrePro.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_OPCION_PRE_PRO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<OpcionesPrePro>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filteropcionesprepro
	 *            OpcionesPrePro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(OpcionesPrePro filteropcionesprepro, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_OPCION_PRE_PRO IDOPCIONPREPRO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM OPCIONES_PRE_PRO t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filteropcionesprepro, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, OpcionesPrePro.class,
				query, params, "ID_OPCION_PRE_PRO");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical OpcionesPrePro table.
	 *
	 * @param filterOpcionesPrePro
	 *            OpcionesPrePro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<OpcionesPrePro>>
	 */
	@Override
	public List<JerarquiaDto<OpcionesPrePro>> findAllLikeJerarquia(OpcionesPrePro filterOpcionesPrePro,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_OPCION_PRE_PRO IDOPCIONPREPRO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM OPCIONES_PRE_PRO t1 ");
		List<String> from = new ArrayList<String>();
		from.add("OPCIONES_PRE_PRO");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterOpcionesPrePro, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_OPCION_PRE_PRO", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					OpcionesPreProDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterOpcionesPrePro
	 *            OpcionesPrePro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(OpcionesPrePro filterOpcionesPrePro, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM OPCIONES_PRE_PRO t1 ");
		List<String> from = new ArrayList<String>();
		from.add("OPCIONES_PRE_PRO");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterOpcionesPrePro, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_OPCION_PRE_PRO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterOpcionesPrePro
	 *            OpcionesPrePro
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<OpcionesPrePro>>
	 */
	@Override
	public List<TableRowDto<OpcionesPrePro>> findAllChild(OpcionesPrePro filterOpcionesPrePro,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM OPCIONES_PRE_PRO t1 ");
		List<String> from = new ArrayList<String>();
		from.add("OPCIONES_PRE_PRO");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterOpcionesPrePro, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_OPCION_PRE_PRO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<OpcionesPrePro>(this.rwMapPK, "ID_OPCION_PRE_PRO"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the OpcionesPrePro entity
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(OpcionesPrePro opcionesprepro) {

		StringBuilder where = new StringBuilder(OpcionesPreProDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (opcionesprepro != null && opcionesprepro.getIdOpcionPrePro() != null) {
			where.append(" AND t1.ID_OPCION_PRE_PRO = ?");
			params.add(opcionesprepro.getIdOpcionPrePro());
		}
		if (opcionesprepro != null && opcionesprepro.getIdPreguntaProtocolo() != null) {
			where.append(" AND t1.ID_PREGUNTA_PROTOCOLO = ?");
			params.add(opcionesprepro.getIdPreguntaProtocolo());
		}
		if (opcionesprepro != null && opcionesprepro.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(opcionesprepro.getDescripcionCastellano());
		}
		if (opcionesprepro != null && opcionesprepro.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(opcionesprepro.getDescripcionEuskera());
		}
		if (opcionesprepro != null && opcionesprepro.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(opcionesprepro.getFechaRegistro());
		}
		if (opcionesprepro != null && opcionesprepro.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(opcionesprepro.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the OpcionesPrePro entity
	 *
	 * @param opcionesprepro
	 *            OpcionesPrePro Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(OpcionesPrePro opcionesprepro, Boolean startsWith) {

		StringBuilder where = new StringBuilder(OpcionesPreProDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (opcionesprepro != null && opcionesprepro.getIdOpcionPrePro() != null) {
			where.append(" AND t1.ID_OPCION_PRE_PRO = ?");
			params.add(opcionesprepro.getIdOpcionPrePro());
		}
		if (opcionesprepro != null && opcionesprepro.getIdPreguntaProtocolo() != null) {
			where.append(" AND t1.ID_PREGUNTA_PROTOCOLO = ?");
			params.add(opcionesprepro.getIdPreguntaProtocolo());
		}
		if (opcionesprepro != null && opcionesprepro.getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(opcionesprepro.getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + opcionesprepro.getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (opcionesprepro != null && opcionesprepro.getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(opcionesprepro.getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + opcionesprepro.getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (opcionesprepro != null && opcionesprepro.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(opcionesprepro.getFechaRegistro());
		}
		if (opcionesprepro != null && opcionesprepro.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(opcionesprepro.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + opcionesprepro.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
